//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
//for OpenGL
#include <windows.h>
#include <Gl/gl.h>
#include <Gl/glu.h>
#include <Gl/glaux.h>
#include <Classes.hpp>

//for OpenGL
#pragma hdrstop

#include "Unit1.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TForm1 *Form1;


// for OpenGL
HGLRC hGLRC;
HDC hDC;
int RotX=0;
int RotY=0;
int RotZ=0;
bool gl_lines=false;
bool var_timer=false;
double fa=-8.5;
// for OpenGL


char CubeArray[8][8][8];// Cube Array for one layer
char Layer=0;// For Find Layer
char CubeArrayAll[508][8][8][8];// Cube Array for all Cube one file
int CubeNumber=0;
int EndCubeNumber=0;
unsigned char CubeArrayFile[32512];

void FuncCubeArrayFile()
{
  unsigned int Number=0;
  char y=7;
  char z=0;
  for(unsigned int n=0; n<32512; n++)
  {
    unsigned char variable=0;
    if(CubeArrayAll[Number][0][y][z]!=1)variable+=1;
    if(CubeArrayAll[Number][1][y][z]!=1)variable+=2;
    if(CubeArrayAll[Number][2][y][z]!=1)variable+=4;
    if(CubeArrayAll[Number][3][y][z]!=1)variable+=8;
    if(CubeArrayAll[Number][4][y][z]!=1)variable+=16;
    if(CubeArrayAll[Number][5][y][z]!=1)variable+=32;
    if(CubeArrayAll[Number][6][y][z]!=1)variable+=64;
    if(CubeArrayAll[Number][7][y][z]!=1)variable+=128;
    CubeArrayFile[n]=variable;

    y--;
    if(y==-1){y=7; z++;}
    if(z==8){z=0; Number++;}
  }
}

void FuncMiniCubeGL(float x, float y, float z)
{
 glBegin(GL_QUADS);
  glColor3f (0, 1, 0);
  glVertex3f( x+0.05f, y+0.05f,z-0.05f);
  glVertex3f( x-0.05f, y+0.05f,z-0.05f);
  glVertex3f( x-0.05f, y+0.05f,z+0.05f);
  glVertex3f( x+0.05f, y+0.05f,z+0.05f);// up
  glVertex3f( x+0.05f, y-0.05f,z-0.05f);
  glVertex3f( x-0.05f, y-0.05f,z-0.05f);
  glVertex3f( x-0.05f, y-0.05f,z+0.05f);
  glVertex3f( x+0.05f, y-0.05f,z+0.05f);// down
  glVertex3f( x+0.05f, y+0.05f,z+0.05f);
  glVertex3f( x-0.05f, y+0.05f,z+0.05f);
  glVertex3f( x-0.05f, y-0.05f,z+0.05f);
  glVertex3f( x+0.05f, y-0.05f,z+0.05f);// front
  glVertex3f( x+0.05f, y-0.05f,z-0.05f);
  glVertex3f( x-0.05f, y-0.05f,z-0.05f);
  glVertex3f( x-0.05f, y+0.05f,z-0.05f);
  glVertex3f( x+0.05f, y+0.05f,z-0.05f);// back
  glVertex3f( x-0.05f, y+0.05f,z+0.05f);
  glVertex3f( x-0.05f, y+0.05f,z-0.05f);
  glVertex3f( x-0.05f, y-0.05f,z-0.05f);
  glVertex3f( x-0.05f, y-0.05f,z+0.05f);// left
  glVertex3f( x+0.05f, y+0.05f,z-0.05f);
  glVertex3f( x+0.05f, y+0.05f,z+0.05f);
  glVertex3f( x+0.05f, y-0.05f,z+0.05f);
  glVertex3f( x+0.05f, y-0.05f,z-0.05f);// right
 glEnd();
}

void FuncOpenGL()
 {
 glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 glLoadIdentity ();
 glTranslatef(0.0f,0.0f,fa); //Point of centr
 glRotatef(RotX,1.0f,0.0f,0.0f); //Rotate for X
 glRotatef(RotY,0.0f,1.0f,0.0f); //Rotate for Y
 glRotatef(RotZ,0.0f,0.0f,1.0f); //Rotate for Z

 glTranslatef(0.0f,0.0f,5.5f); //Point of begin
 glBegin(GL_QUADS);
  glColor3f (1, 0.6, 0);// up
  glVertex3f( 4.0f,-3.0f,-9.5f);
  glVertex3f(-4.0f,-3.0f,-9.5f);
  glVertex3f(-4.0f,-3.0f,-1.5f);
  glVertex3f( 4.0f,-3.0f,-1.5f);

  glColor3f (1, 0.6, 0);// down
  glVertex3f( 4.0f,-3.1f,-9.5f);
  glVertex3f(-4.0f,-3.1f,-9.5f);
  glVertex3f(-4.0f,-3.1f,-1.5f);
  glVertex3f( 4.0f,-3.1f,-1.5f);


 glEnd();

 if(gl_lines==true)
 {
 glBegin(GL_LINES);
  glColor3f (1, 1, 1);// line
  glVertex3f(-3.5f, 4.0f,-2.0f);  glVertex3f(-3.5f,-3.1f,-2.0f);//1-1
  glVertex3f(-2.5f, 4.0f,-2.0f);  glVertex3f(-2.5f,-3.1f,-2.0f);//2
  glVertex3f(-1.5f, 4.0f,-2.0f);  glVertex3f(-1.5f,-3.1f,-2.0f);//3
  glVertex3f(-0.5f, 4.0f,-2.0f);  glVertex3f(-0.5f,-3.1f,-2.0f);//4
  glVertex3f( 0.5f, 4.0f,-2.0f);  glVertex3f( 0.5f,-3.1f,-2.0f);//5
  glVertex3f( 1.5f, 4.0f,-2.0f);  glVertex3f( 1.5f,-3.1f,-2.0f);//6
  glVertex3f( 2.5f, 4.0f,-2.0f);  glVertex3f( 2.5f,-3.1f,-2.0f);//7
  glVertex3f( 3.5f, 4.0f,-2.0f);  glVertex3f( 3.5f,-3.1f,-2.0f);//8

  glVertex3f(-3.5f, 4.0f,-3.0f);  glVertex3f(-3.5f,-3.1f,-3.0f);//1-2
  glVertex3f(-2.5f, 4.0f,-3.0f);  glVertex3f(-2.5f,-3.1f,-3.0f);//2
  glVertex3f(-1.5f, 4.0f,-3.0f);  glVertex3f(-1.5f,-3.1f,-3.0f);//3
  glVertex3f(-0.5f, 4.0f,-3.0f);  glVertex3f(-0.5f,-3.1f,-3.0f);//4
  glVertex3f( 0.5f, 4.0f,-3.0f);  glVertex3f( 0.5f,-3.1f,-3.0f);//5
  glVertex3f( 1.5f, 4.0f,-3.0f);  glVertex3f( 1.5f,-3.1f,-3.0f);//6
  glVertex3f( 2.5f, 4.0f,-3.0f);  glVertex3f( 2.5f,-3.1f,-3.0f);//7
  glVertex3f( 3.5f, 4.0f,-3.0f);  glVertex3f( 3.5f,-3.1f,-3.0f);//8

  glVertex3f(-3.5f, 4.0f,-4.0f);  glVertex3f(-3.5f,-3.1f,-4.0f);//1-3
  glVertex3f(-2.5f, 4.0f,-4.0f);  glVertex3f(-2.5f,-3.1f,-4.0f);//2
  glVertex3f(-1.5f, 4.0f,-4.0f);  glVertex3f(-1.5f,-3.1f,-4.0f);//3
  glVertex3f(-0.5f, 4.0f,-4.0f);  glVertex3f(-0.5f,-3.1f,-4.0f);//4
  glVertex3f( 0.5f, 4.0f,-4.0f);  glVertex3f( 0.5f,-3.1f,-4.0f);//5
  glVertex3f( 1.5f, 4.0f,-4.0f);  glVertex3f( 1.5f,-3.1f,-4.0f);//6
  glVertex3f( 2.5f, 4.0f,-4.0f);  glVertex3f( 2.5f,-3.1f,-4.0f);//7
  glVertex3f( 3.5f, 4.0f,-4.0f);  glVertex3f( 3.5f,-3.1f,-4.0f);//8

  glVertex3f(-3.5f, 4.0f,-5.0f);  glVertex3f(-3.5f,-3.1f,-5.0f);//1-4
  glVertex3f(-2.5f, 4.0f,-5.0f);  glVertex3f(-2.5f,-3.1f,-5.0f);//2
  glVertex3f(-1.5f, 4.0f,-5.0f);  glVertex3f(-1.5f,-3.1f,-5.0f);//3
  glVertex3f(-0.5f, 4.0f,-5.0f);  glVertex3f(-0.5f,-3.1f,-5.0f);//4
  glVertex3f( 0.5f, 4.0f,-5.0f);  glVertex3f( 0.5f,-3.1f,-5.0f);//5
  glVertex3f( 1.5f, 4.0f,-5.0f);  glVertex3f( 1.5f,-3.1f,-5.0f);//6
  glVertex3f( 2.5f, 4.0f,-5.0f);  glVertex3f( 2.5f,-3.1f,-5.0f);//7
  glVertex3f( 3.5f, 4.0f,-5.0f);  glVertex3f( 3.5f,-3.1f,-5.0f);//8

  glVertex3f(-3.5f, 4.0f,-6.0f);  glVertex3f(-3.5f,-3.1f,-6.0f);//1-5
  glVertex3f(-2.5f, 4.0f,-6.0f);  glVertex3f(-2.5f,-3.1f,-6.0f);//2
  glVertex3f(-1.5f, 4.0f,-6.0f);  glVertex3f(-1.5f,-3.1f,-6.0f);//3
  glVertex3f(-0.5f, 4.0f,-6.0f);  glVertex3f(-0.5f,-3.1f,-6.0f);//4
  glVertex3f( 0.5f, 4.0f,-6.0f);  glVertex3f( 0.5f,-3.1f,-6.0f);//5
  glVertex3f( 1.5f, 4.0f,-6.0f);  glVertex3f( 1.5f,-3.1f,-6.0f);//6
  glVertex3f( 2.5f, 4.0f,-6.0f);  glVertex3f( 2.5f,-3.1f,-6.0f);//7
  glVertex3f( 3.5f, 4.0f,-6.0f);  glVertex3f( 3.5f,-3.1f,-6.0f);//8

  glVertex3f(-3.5f, 4.0f,-7.0f);  glVertex3f(-3.5f,-3.1f,-7.0f);//1-6
  glVertex3f(-2.5f, 4.0f,-7.0f);  glVertex3f(-2.5f,-3.1f,-7.0f);//2
  glVertex3f(-1.5f, 4.0f,-7.0f);  glVertex3f(-1.5f,-3.1f,-7.0f);//3
  glVertex3f(-0.5f, 4.0f,-7.0f);  glVertex3f(-0.5f,-3.1f,-7.0f);//4
  glVertex3f( 0.5f, 4.0f,-7.0f);  glVertex3f( 0.5f,-3.1f,-7.0f);//5
  glVertex3f( 1.5f, 4.0f,-7.0f);  glVertex3f( 1.5f,-3.1f,-7.0f);//6
  glVertex3f( 2.5f, 4.0f,-7.0f);  glVertex3f( 2.5f,-3.1f,-7.0f);//7
  glVertex3f( 3.5f, 4.0f,-7.0f);  glVertex3f( 3.5f,-3.1f,-7.0f);//8

  glVertex3f(-3.5f, 4.0f,-8.0f);  glVertex3f(-3.5f,-3.1f,-8.0f);//1-7
  glVertex3f(-2.5f, 4.0f,-8.0f);  glVertex3f(-2.5f,-3.1f,-8.0f);//2
  glVertex3f(-1.5f, 4.0f,-8.0f);  glVertex3f(-1.5f,-3.1f,-8.0f);//3
  glVertex3f(-0.5f, 4.0f,-8.0f);  glVertex3f(-0.5f,-3.1f,-8.0f);//4
  glVertex3f( 0.5f, 4.0f,-8.0f);  glVertex3f( 0.5f,-3.1f,-8.0f);//5
  glVertex3f( 1.5f, 4.0f,-8.0f);  glVertex3f( 1.5f,-3.1f,-8.0f);//6
  glVertex3f( 2.5f, 4.0f,-8.0f);  glVertex3f( 2.5f,-3.1f,-8.0f);//7
  glVertex3f( 3.5f, 4.0f,-8.0f);  glVertex3f( 3.5f,-3.1f,-8.0f);//8

  glVertex3f(-3.5f, 4.0f,-9.0f);  glVertex3f(-3.5f,-3.1f,-9.0f);//1-8
  glVertex3f(-2.5f, 4.0f,-9.0f);  glVertex3f(-2.5f,-3.1f,-9.0f);//2
  glVertex3f(-1.5f, 4.0f,-9.0f);  glVertex3f(-1.5f,-3.1f,-9.0f);//3
  glVertex3f(-0.5f, 4.0f,-9.0f);  glVertex3f(-0.5f,-3.1f,-9.0f);//4
  glVertex3f( 0.5f, 4.0f,-9.0f);  glVertex3f( 0.5f,-3.1f,-9.0f);//5
  glVertex3f( 1.5f, 4.0f,-9.0f);  glVertex3f( 1.5f,-3.1f,-9.0f);//6
  glVertex3f( 2.5f, 4.0f,-9.0f);  glVertex3f( 2.5f,-3.1f,-9.0f);//7
  glVertex3f( 3.5f, 4.0f,-9.0f);  glVertex3f( 3.5f,-3.1f,-9.0f);//8

  glVertex3f(-3.5f,-3.0f,-2.0f);  glVertex3f( 3.5f,-3.0f,-2.0f);//1-2-1
  glVertex3f(-3.5f,-2.0f,-2.0f);  glVertex3f( 3.5f,-2.0f,-2.0f);//2
  glVertex3f(-3.5f,-1.0f,-2.0f);  glVertex3f( 3.5f,-1.0f,-2.0f);//3
  glVertex3f(-3.5f, 0.0f,-2.0f);  glVertex3f( 3.5f, 0.0f,-2.0f);//4
  glVertex3f(-3.5f, 1.0f,-2.0f);  glVertex3f( 3.5f, 1.0f,-2.0f);//5
  glVertex3f(-3.5f, 2.0f,-2.0f);  glVertex3f( 3.5f, 2.0f,-2.0f);//6
  glVertex3f(-3.5f, 3.0f,-2.0f);  glVertex3f( 3.5f, 3.0f,-2.0f);//7
  glVertex3f(-3.5f, 4.0f,-2.0f);  glVertex3f( 3.5f, 4.0f,-2.0f);//8

  glVertex3f(-3.5f,-3.0f,-3.0f);  glVertex3f( 3.5f,-3.0f,-3.0f);//1-2-2
  glVertex3f(-3.5f,-2.0f,-3.0f);  glVertex3f( 3.5f,-2.0f,-3.0f);//2
  glVertex3f(-3.5f,-1.0f,-3.0f);  glVertex3f( 3.5f,-1.0f,-3.0f);//3
  glVertex3f(-3.5f, 0.0f,-3.0f);  glVertex3f( 3.5f, 0.0f,-3.0f);//4
  glVertex3f(-3.5f, 1.0f,-3.0f);  glVertex3f( 3.5f, 1.0f,-3.0f);//5
  glVertex3f(-3.5f, 2.0f,-3.0f);  glVertex3f( 3.5f, 2.0f,-3.0f);//6
  glVertex3f(-3.5f, 3.0f,-3.0f);  glVertex3f( 3.5f, 3.0f,-3.0f);//7
  glVertex3f(-3.5f, 4.0f,-3.0f);  glVertex3f( 3.5f, 4.0f,-3.0f);//8

  glVertex3f(-3.5f,-3.0f,-4.0f);  glVertex3f( 3.5f,-3.0f,-4.0f);//1-2-3
  glVertex3f(-3.5f,-2.0f,-4.0f);  glVertex3f( 3.5f,-2.0f,-4.0f);//2
  glVertex3f(-3.5f,-1.0f,-4.0f);  glVertex3f( 3.5f,-1.0f,-4.0f);//3
  glVertex3f(-3.5f, 0.0f,-4.0f);  glVertex3f( 3.5f, 0.0f,-4.0f);//4
  glVertex3f(-3.5f, 1.0f,-4.0f);  glVertex3f( 3.5f, 1.0f,-4.0f);//5
  glVertex3f(-3.5f, 2.0f,-4.0f);  glVertex3f( 3.5f, 2.0f,-4.0f);//6
  glVertex3f(-3.5f, 3.0f,-4.0f);  glVertex3f( 3.5f, 3.0f,-4.0f);//7
  glVertex3f(-3.5f, 4.0f,-4.0f);  glVertex3f( 3.5f, 4.0f,-4.0f);//8

  glVertex3f(-3.5f,-3.0f,-5.0f);  glVertex3f( 3.5f,-3.0f,-5.0f);//1-2-4
  glVertex3f(-3.5f,-2.0f,-5.0f);  glVertex3f( 3.5f,-2.0f,-5.0f);//2
  glVertex3f(-3.5f,-1.0f,-5.0f);  glVertex3f( 3.5f,-1.0f,-5.0f);//3
  glVertex3f(-3.5f, 0.0f,-5.0f);  glVertex3f( 3.5f, 0.0f,-5.0f);//4
  glVertex3f(-3.5f, 1.0f,-5.0f);  glVertex3f( 3.5f, 1.0f,-5.0f);//5
  glVertex3f(-3.5f, 2.0f,-5.0f);  glVertex3f( 3.5f, 2.0f,-5.0f);//6
  glVertex3f(-3.5f, 3.0f,-5.0f);  glVertex3f( 3.5f, 3.0f,-5.0f);//7
  glVertex3f(-3.5f, 4.0f,-5.0f);  glVertex3f( 3.5f, 4.0f,-5.0f);//8

  glVertex3f(-3.5f,-3.0f,-6.0f);  glVertex3f( 3.5f,-3.0f,-6.0f);//1-2-5
  glVertex3f(-3.5f,-2.0f,-6.0f);  glVertex3f( 3.5f,-2.0f,-6.0f);//2
  glVertex3f(-3.5f,-1.0f,-6.0f);  glVertex3f( 3.5f,-1.0f,-6.0f);//3
  glVertex3f(-3.5f, 0.0f,-6.0f);  glVertex3f( 3.5f, 0.0f,-6.0f);//4
  glVertex3f(-3.5f, 1.0f,-6.0f);  glVertex3f( 3.5f, 1.0f,-6.0f);//5
  glVertex3f(-3.5f, 2.0f,-6.0f);  glVertex3f( 3.5f, 2.0f,-6.0f);//6
  glVertex3f(-3.5f, 3.0f,-6.0f);  glVertex3f( 3.5f, 3.0f,-6.0f);//7
  glVertex3f(-3.5f, 4.0f,-6.0f);  glVertex3f( 3.5f, 4.0f,-6.0f);//8

  glVertex3f(-3.5f,-3.0f,-7.0f);  glVertex3f( 3.5f,-3.0f,-7.0f);//1-2-6
  glVertex3f(-3.5f,-2.0f,-7.0f);  glVertex3f( 3.5f,-2.0f,-7.0f);//2
  glVertex3f(-3.5f,-1.0f,-7.0f);  glVertex3f( 3.5f,-1.0f,-7.0f);//3
  glVertex3f(-3.5f, 0.0f,-7.0f);  glVertex3f( 3.5f, 0.0f,-7.0f);//4
  glVertex3f(-3.5f, 1.0f,-7.0f);  glVertex3f( 3.5f, 1.0f,-7.0f);//5
  glVertex3f(-3.5f, 2.0f,-7.0f);  glVertex3f( 3.5f, 2.0f,-7.0f);//6
  glVertex3f(-3.5f, 3.0f,-7.0f);  glVertex3f( 3.5f, 3.0f,-7.0f);//7
  glVertex3f(-3.5f, 4.0f,-7.0f);  glVertex3f( 3.5f, 4.0f,-7.0f);//8

  glVertex3f(-3.5f,-3.0f,-8.0f);  glVertex3f( 3.5f,-3.0f,-8.0f);//1-2-7
  glVertex3f(-3.5f,-2.0f,-8.0f);  glVertex3f( 3.5f,-2.0f,-8.0f);//2
  glVertex3f(-3.5f,-1.0f,-8.0f);  glVertex3f( 3.5f,-1.0f,-8.0f);//3
  glVertex3f(-3.5f, 0.0f,-8.0f);  glVertex3f( 3.5f, 0.0f,-8.0f);//4
  glVertex3f(-3.5f, 1.0f,-8.0f);  glVertex3f( 3.5f, 1.0f,-8.0f);//5
  glVertex3f(-3.5f, 2.0f,-8.0f);  glVertex3f( 3.5f, 2.0f,-8.0f);//6
  glVertex3f(-3.5f, 3.0f,-8.0f);  glVertex3f( 3.5f, 3.0f,-8.0f);//7
  glVertex3f(-3.5f, 4.0f,-8.0f);  glVertex3f( 3.5f, 4.0f,-8.0f);//8

  glVertex3f(-3.5f,-3.0f,-9.0f);  glVertex3f( 3.5f,-3.0f,-9.0f);//1-2-8
  glVertex3f(-3.5f,-2.0f,-9.0f);  glVertex3f( 3.5f,-2.0f,-9.0f);//2
  glVertex3f(-3.5f,-1.0f,-9.0f);  glVertex3f( 3.5f,-1.0f,-9.0f);//3
  glVertex3f(-3.5f, 0.0f,-9.0f);  glVertex3f( 3.5f, 0.0f,-9.0f);//4
  glVertex3f(-3.5f, 1.0f,-9.0f);  glVertex3f( 3.5f, 1.0f,-9.0f);//5
  glVertex3f(-3.5f, 2.0f,-9.0f);  glVertex3f( 3.5f, 2.0f,-9.0f);//6
  glVertex3f(-3.5f, 3.0f,-9.0f);  glVertex3f( 3.5f, 3.0f,-9.0f);//7
  glVertex3f(-3.5f, 4.0f,-9.0f);  glVertex3f( 3.5f, 4.0f,-9.0f);//8

 glEnd();
 }

 double x_cube;
 double y_cube;
 double z_cube;

 for(char x=0; x<8; x++)
 {
  for(char y=0; y<8; y++)
  {
   for(char z=0; z<8; z++)
   {
    switch(x)
      {
      case 0: x_cube= 3.5; break;
      case 1: x_cube= 2.5; break;
      case 2: x_cube= 1.5; break;
      case 3: x_cube= 0.5; break;
      case 4: x_cube=-0.5; break;
      case 5: x_cube=-1.5; break;
      case 6: x_cube=-2.5; break;
      case 7: x_cube=-3.5; break;
      }
    switch(y)
      {
      case 0: y_cube=-3.0; break;
      case 1: y_cube=-2.0; break;
      case 2: y_cube=-1.0; break;
      case 3: y_cube= 0.0; break;
      case 4: y_cube= 1.0; break;
      case 5: y_cube= 2.0; break;
      case 6: y_cube= 3.0; break;
      case 7: y_cube= 4.0; break;
      }
    switch(z)
      {
      case 0: z_cube=-2.0; break;
      case 1: z_cube=-3.0; break;
      case 2: z_cube=-4.0; break;
      case 3: z_cube=-5.0; break;
      case 4: z_cube=-6.0; break;
      case 5: z_cube=-7.0; break;
      case 6: z_cube=-8.0; break;
      case 7: z_cube=-9.0; break;
      }
    if(CubeArray[x][y][z]==1)
     {
     FuncMiniCubeGL(x_cube,y_cube,z_cube);
     }
   }
  }
 }

 glFlush ();
 SwapBuffers(hDC);
 }


void FuncInsertCube()
{
 for(int n=507; n>CubeNumber; n--)
 {
  for(char x=0; x<8; x++)
  {
   for(char y=0; y<8; y++)
   {
    for(char z=0; z<8; z++)
    {
     int n1=n-1;
     CubeArrayAll[n][x][y][z]=CubeArrayAll[n1][x][y][z];
    }
   }
  }
 }
}

void FuncClearCube()
{
 for(char x=0; x<8; x++)
 {
  for(char y=0; y<8; y++)
  {
   for(char z=0; z<8; z++)
   {
    CubeArrayAll[CubeNumber][x][y][z]=0;
    CubeArray[x][y][z]=CubeArrayAll[CubeNumber][x][y][z];
   }
  }
 }
}


void FuncDuplicateCube(char Button, int Qua)
{
 if(Button==1 && Qua>0)
 {
  for(int n=1; n<=Qua; n++)
  {
   for(char x=0; x<8; x++)
   {
    for(char y=0; y<8; y++)
    {
     for(char z=0; z<8; z++)
     {
      int Numb=CubeNumber+n;
      if(Numb>-1 && Numb<508)
      {
       CubeArrayAll[Numb][x][y][z]=CubeArray[x][y][z];
      }
      else
      {
       Form1->Label8->Caption="Error E01";
      }
     }
    }
   }
  }
 }
 if(Button==-1 && Qua>0)
 {
  for(int n=1; n<=Qua; n++)
  {
   for(char x=0; x<8; x++)
   {
    for(char y=0; y<8; y++)
    {
     for(char z=0; z<8; z++)
     {
      int Numb=CubeNumber-n;
      if(Numb>-1 && Numb<508)
      {
       CubeArrayAll[Numb][x][y][z]=CubeArray[x][y][z];
      }
      else
      {
       Form1->Label8->Caption="Error E01";
      }
     }
    }
   }
  }
 }
 if(Qua<1)
 {
  Form1->Label8->Caption="Error E02";
 }
}



void FuncChangeCubeNum(int NumCube)
{
  for(char x=0; x<8; x++)
    {
      for(char y=0; y<8; y++)
      {
        for(char z=0; z<8; z++)
        {
        CubeArrayAll[CubeNumber][x][y][z]=CubeArray[x][y][z];
        CubeArray[x][y][z]=CubeArrayAll[NumCube][x][y][z];
        }
      }
    }
  CubeNumber=NumCube;
}

void FuncChangeCube(char Button)// Button=1 Next, Button=-1 Previous
{
  if(Button==1 && CubeNumber<507)
  {
    for(char x=0; x<8; x++)
    {
      for(char y=0; y<8; y++)
      {
        for(char z=0; z<8; z++)
        {
        CubeArrayAll[CubeNumber][x][y][z]=CubeArray[x][y][z];
        CubeArray[x][y][z]=CubeArrayAll[CubeNumber+1][x][y][z];
        }
      }
    }
    CubeNumber++;
    if(CubeNumber==507)Form1->Button70->Enabled=false;
    else Form1->Button69->Enabled=true;
  }
  if(Button==-1 && CubeNumber>0)
  {
    for(char x=0; x<8; x++)
    {
      for(char y=0; y<8; y++)
      {
        for(char z=0; z<8; z++)
        {
        CubeArrayAll[CubeNumber][x][y][z]=CubeArray[x][y][z];
        CubeArray[x][y][z]=CubeArrayAll[CubeNumber-1][x][y][z];
        }
      }
    }
    CubeNumber--;
    if(CubeNumber==0)Form1->Button69->Enabled=false;
    else Form1->Button70->Enabled=true;
  }
}

void FuncChangeStates(char &States, TSpeedButton *SButton)
{
 if(States==0 || States==-1)
 {
  States=1;
  SButton->Glyph->LoadFromFile("green.bmp");
 }
 else
 {
 States=-1;
 SButton->Glyph=NULL;
 }
FuncOpenGL();
}

void FuncChangeImageArrow(TImage *Left, TImage *Right, TImage *Down,
                          TLabel *Left_L, TLabel *Right_L, TLabel *Down_L_L,
                          TLabel *Down_L_R)
{
 if(Layer>=1 && Layer<=8)
 {
  Right->Picture->LoadFromFile("to_up.bmp");
  Down->Picture->LoadFromFile("to_left.bmp");
  Left->Picture=NULL;
  Right_L->Caption="Y";
  Down_L_L->Caption="X";
  Down_L_R->Caption=" ";
  Left_L->Caption=" ";
 }
 if(Layer>=9 && Layer<=16)
 {
  Right->Picture=NULL;
  Down->Picture->LoadFromFile("to_right.bmp");
  Left->Picture->LoadFromFile("to_up.bmp");
  Right_L->Caption=" ";
  Down_L_L->Caption=" ";
  Down_L_R->Caption="Z";
  Left_L->Caption="Y";
 }
 if(Layer>=17 && Layer<=24)
 {
  Right->Picture->LoadFromFile("to_up.bmp");
  Down->Picture->LoadFromFile("to_left.bmp");
  Left->Picture=NULL;
  Right_L->Caption="Z";
  Down_L_L->Caption="X";
  Down_L_R->Caption=" ";
  Left_L->Caption=" ";
 }
}

char FuncWhatNumberLayer()
{
char n=-1;
if(Layer==1 || Layer==9 || Layer==17)n=0;
if(Layer==2 || Layer==10 || Layer==18)n=1;
if(Layer==3 || Layer==11 || Layer==19)n=2;
if(Layer==4 || Layer==12 || Layer==20)n=3;
if(Layer==5 || Layer==13 || Layer==21)n=4;
if(Layer==6 || Layer==14 || Layer==22)n=5;
if(Layer==7 || Layer==15 || Layer==23)n=6;
if(Layer==8 || Layer==16 || Layer==24)n=7;
return(n);
}

void FuncButtonLayer(char Button)// Button=1 Next, Button=-1 Previous
{
  if(Layer>=1 && Layer<=8)
  {
    if(Layer<8 && Button==1)Layer++;
    else {if(Button==1)Layer=1;}
    if(Layer>1 && Button==-1)Layer--;
    else {if(Button==-1)Layer=8;}
    switch(Layer)
      {
      case 1: Form1->RadioButton1->Checked=true; break;
      case 2: Form1->RadioButton2->Checked=true; break;
      case 3: Form1->RadioButton3->Checked=true; break;
      case 4: Form1->RadioButton4->Checked=true; break;
      case 5: Form1->RadioButton5->Checked=true; break;
      case 6: Form1->RadioButton6->Checked=true; break;
      case 7: Form1->RadioButton7->Checked=true; break;
      case 8: Form1->RadioButton8->Checked=true; break;
      }
  }
  if(Layer>=9 && Layer<=16)
  {
    if(Layer<16 && Button==1)Layer++;
    else {if(Button==1)Layer=9;}
    if(Layer>9 && Button==-1)Layer--;
    else {if(Button==-1)Layer=16;}
    switch(Layer)
      {
      case 9: Form1->RadioButton9->Checked=true; break;
      case 10: Form1->RadioButton10->Checked=true; break;
      case 11: Form1->RadioButton11->Checked=true; break;
      case 12: Form1->RadioButton12->Checked=true; break;
      case 13: Form1->RadioButton13->Checked=true; break;
      case 14: Form1->RadioButton14->Checked=true; break;
      case 15: Form1->RadioButton15->Checked=true; break;
      case 16: Form1->RadioButton16->Checked=true; break;
      }
  }
  if(Layer>=17 && Layer<=24)
  {
    if(Layer<24 && Button==1)Layer++;
    else {if(Button==1)Layer=17;}
    if(Layer>17 && Button==-1)Layer--;
    else {if(Button==-1)Layer=24;}
    switch(Layer)
      {
      case 17: Form1->RadioButton17->Checked=true; break;
      case 18: Form1->RadioButton18->Checked=true; break;
      case 19: Form1->RadioButton19->Checked=true; break;
      case 20: Form1->RadioButton20->Checked=true; break;
      case 21: Form1->RadioButton21->Checked=true; break;
      case 22: Form1->RadioButton22->Checked=true; break;
      case 23: Form1->RadioButton23->Checked=true; break;
      case 24: Form1->RadioButton24->Checked=true; break;
      }
  }
}

void FuncClearLayer()
{
  if(Layer>=1 && Layer<=8)
  {
    char z=FuncWhatNumberLayer();
    for(char x=0; x<8; x++)
    {
      for(char y=0; y<8; y++)
      {
        CubeArray[x][y][z]=-1;
      }
    }
  }
  if(Layer>=9 && Layer<=16)
  {
    char x=FuncWhatNumberLayer();
    for(char y=0; y<8; y++)
    {
      for(char z=0; z<8; z++)
      {
        CubeArray[x][y][z]=-1;
      }
    }
  }
  if(Layer>=17 && Layer<=24)
  {
    char y=FuncWhatNumberLayer();
    for(char x=0; x<8; x++)
    {
      for(char z=0; z<8; z++)
      {
        CubeArray[x][y][z]=-1;
      }
    }
  }
}

void FuncDuplicateLayerPrev()
{
  if(Layer>=2 && Layer<=8)
  {
    char z=FuncWhatNumberLayer();
    for(char x=0; x<8; x++)
    {
      for(char y=0; y<8; y++)
      {
        CubeArray[x][y][z]=CubeArray[x][y][z-1];
      }
    }
  }
  if(Layer>=10 && Layer<=16)
  {
    char x=FuncWhatNumberLayer();
    for(char y=0; y<8; y++)
    {
      for(char z=0; z<8; z++)
      {
        CubeArray[x][y][z]=CubeArray[x-1][y][z];
      }
    }
  }
  if(Layer>=18 && Layer<=24)
  {
    char y=FuncWhatNumberLayer();
    for(char x=0; x<8; x++)
    {
      for(char z=0; z<8; z++)
      {
        CubeArray[x][y][z]=CubeArray[x][y-1][z];
      }
    }
  }
}




void FuncDuplicateLayerNext()
{
  if(Layer>=1 && Layer<=7)
  {
    char z=FuncWhatNumberLayer();
    for(char x=0; x<8; x++)
    {
      for(char y=0; y<8; y++)
      {
        CubeArray[x][y][z]=CubeArray[x][y][z+1];
      }
    }
  }
  if(Layer>=9 && Layer<=15)
  {
    char x=FuncWhatNumberLayer();
    for(char y=0; y<8; y++)
    {
      for(char z=0; z<8; z++)
      {
        CubeArray[x][y][z]=CubeArray[x+1][y][z];
      }
    }
  }
  if(Layer>=17 && Layer<=23)
  {
    char y=FuncWhatNumberLayer();
    for(char x=0; x<8; x++)
    {
      for(char z=0; z<8; z++)
      {
        CubeArray[x][y][z]=CubeArray[x][y+1][z];
      }
    }
  }
}




void FuncCIB(TSpeedButton *SB, char states_b)// Function Change Image Button
{
  if(states_b==0 || states_b==-1)
   {
    SB->Glyph=NULL;
   }
   else
   {
    SB->Glyph->LoadFromFile("green.bmp");
   }
}

void FuncDrow()
{
if(CubeNumber==0)Form1->Button69->Enabled=false;
if(Layer>=1 && Layer<=8)
  {
    char z=FuncWhatNumberLayer();
    FuncCIB(Form1->SpeedButton1,CubeArray[7][7][z]);
    FuncCIB(Form1->SpeedButton2,CubeArray[6][7][z]);
    FuncCIB(Form1->SpeedButton3,CubeArray[5][7][z]);
    FuncCIB(Form1->SpeedButton4,CubeArray[4][7][z]);
    FuncCIB(Form1->SpeedButton5,CubeArray[3][7][z]);
    FuncCIB(Form1->SpeedButton6,CubeArray[2][7][z]);
    FuncCIB(Form1->SpeedButton7,CubeArray[1][7][z]);
    FuncCIB(Form1->SpeedButton8,CubeArray[0][7][z]);

    FuncCIB(Form1->SpeedButton9,CubeArray[7][6][z]);
    FuncCIB(Form1->SpeedButton10,CubeArray[6][6][z]);
    FuncCIB(Form1->SpeedButton11,CubeArray[5][6][z]);
    FuncCIB(Form1->SpeedButton12,CubeArray[4][6][z]);
    FuncCIB(Form1->SpeedButton13,CubeArray[3][6][z]);
    FuncCIB(Form1->SpeedButton14,CubeArray[2][6][z]);
    FuncCIB(Form1->SpeedButton15,CubeArray[1][6][z]);
    FuncCIB(Form1->SpeedButton16,CubeArray[0][6][z]);

    FuncCIB(Form1->SpeedButton17,CubeArray[7][5][z]);
    FuncCIB(Form1->SpeedButton18,CubeArray[6][5][z]);
    FuncCIB(Form1->SpeedButton19,CubeArray[5][5][z]);
    FuncCIB(Form1->SpeedButton20,CubeArray[4][5][z]);
    FuncCIB(Form1->SpeedButton21,CubeArray[3][5][z]);
    FuncCIB(Form1->SpeedButton22,CubeArray[2][5][z]);
    FuncCIB(Form1->SpeedButton23,CubeArray[1][5][z]);
    FuncCIB(Form1->SpeedButton24,CubeArray[0][5][z]);

    FuncCIB(Form1->SpeedButton25,CubeArray[7][4][z]);
    FuncCIB(Form1->SpeedButton26,CubeArray[6][4][z]);
    FuncCIB(Form1->SpeedButton27,CubeArray[5][4][z]);
    FuncCIB(Form1->SpeedButton28,CubeArray[4][4][z]);
    FuncCIB(Form1->SpeedButton29,CubeArray[3][4][z]);
    FuncCIB(Form1->SpeedButton30,CubeArray[2][4][z]);
    FuncCIB(Form1->SpeedButton31,CubeArray[1][4][z]);
    FuncCIB(Form1->SpeedButton32,CubeArray[0][4][z]);

    FuncCIB(Form1->SpeedButton33,CubeArray[7][3][z]);
    FuncCIB(Form1->SpeedButton34,CubeArray[6][3][z]);
    FuncCIB(Form1->SpeedButton35,CubeArray[5][3][z]);
    FuncCIB(Form1->SpeedButton36,CubeArray[4][3][z]);
    FuncCIB(Form1->SpeedButton37,CubeArray[3][3][z]);
    FuncCIB(Form1->SpeedButton38,CubeArray[2][3][z]);
    FuncCIB(Form1->SpeedButton39,CubeArray[1][3][z]);
    FuncCIB(Form1->SpeedButton40,CubeArray[0][3][z]);

    FuncCIB(Form1->SpeedButton41,CubeArray[7][2][z]);
    FuncCIB(Form1->SpeedButton42,CubeArray[6][2][z]);
    FuncCIB(Form1->SpeedButton43,CubeArray[5][2][z]);
    FuncCIB(Form1->SpeedButton44,CubeArray[4][2][z]);
    FuncCIB(Form1->SpeedButton45,CubeArray[3][2][z]);
    FuncCIB(Form1->SpeedButton46,CubeArray[2][2][z]);
    FuncCIB(Form1->SpeedButton47,CubeArray[1][2][z]);
    FuncCIB(Form1->SpeedButton48,CubeArray[0][2][z]);

    FuncCIB(Form1->SpeedButton49,CubeArray[7][1][z]);
    FuncCIB(Form1->SpeedButton50,CubeArray[6][1][z]);
    FuncCIB(Form1->SpeedButton51,CubeArray[5][1][z]);
    FuncCIB(Form1->SpeedButton52,CubeArray[4][1][z]);
    FuncCIB(Form1->SpeedButton53,CubeArray[3][1][z]);
    FuncCIB(Form1->SpeedButton54,CubeArray[2][1][z]);
    FuncCIB(Form1->SpeedButton55,CubeArray[1][1][z]);
    FuncCIB(Form1->SpeedButton56,CubeArray[0][1][z]);

    FuncCIB(Form1->SpeedButton57,CubeArray[7][0][z]);
    FuncCIB(Form1->SpeedButton58,CubeArray[6][0][z]);
    FuncCIB(Form1->SpeedButton59,CubeArray[5][0][z]);
    FuncCIB(Form1->SpeedButton60,CubeArray[4][0][z]);
    FuncCIB(Form1->SpeedButton61,CubeArray[3][0][z]);
    FuncCIB(Form1->SpeedButton62,CubeArray[2][0][z]);
    FuncCIB(Form1->SpeedButton63,CubeArray[1][0][z]);
    FuncCIB(Form1->SpeedButton64,CubeArray[0][0][z]);

  }
  if(Layer>=9 && Layer<=16)
  {
    char x=FuncWhatNumberLayer();
    FuncCIB(Form1->SpeedButton1,CubeArray[x][7][0]);
    FuncCIB(Form1->SpeedButton2,CubeArray[x][7][1]);
    FuncCIB(Form1->SpeedButton3,CubeArray[x][7][2]);
    FuncCIB(Form1->SpeedButton4,CubeArray[x][7][3]);
    FuncCIB(Form1->SpeedButton5,CubeArray[x][7][4]);
    FuncCIB(Form1->SpeedButton6,CubeArray[x][7][5]);
    FuncCIB(Form1->SpeedButton7,CubeArray[x][7][6]);
    FuncCIB(Form1->SpeedButton8,CubeArray[x][7][7]);

    FuncCIB(Form1->SpeedButton9,CubeArray[x][6][0]);
    FuncCIB(Form1->SpeedButton10,CubeArray[x][6][1]);
    FuncCIB(Form1->SpeedButton11,CubeArray[x][6][2]);
    FuncCIB(Form1->SpeedButton12,CubeArray[x][6][3]);
    FuncCIB(Form1->SpeedButton13,CubeArray[x][6][4]);
    FuncCIB(Form1->SpeedButton14,CubeArray[x][6][5]);
    FuncCIB(Form1->SpeedButton15,CubeArray[x][6][6]);
    FuncCIB(Form1->SpeedButton16,CubeArray[x][6][7]);

    FuncCIB(Form1->SpeedButton17,CubeArray[x][5][0]);
    FuncCIB(Form1->SpeedButton18,CubeArray[x][5][1]);
    FuncCIB(Form1->SpeedButton19,CubeArray[x][5][2]);
    FuncCIB(Form1->SpeedButton20,CubeArray[x][5][3]);
    FuncCIB(Form1->SpeedButton21,CubeArray[x][5][4]);
    FuncCIB(Form1->SpeedButton22,CubeArray[x][5][5]);
    FuncCIB(Form1->SpeedButton23,CubeArray[x][5][6]);
    FuncCIB(Form1->SpeedButton24,CubeArray[x][5][7]);

    FuncCIB(Form1->SpeedButton25,CubeArray[x][4][0]);
    FuncCIB(Form1->SpeedButton26,CubeArray[x][4][1]);
    FuncCIB(Form1->SpeedButton27,CubeArray[x][4][2]);
    FuncCIB(Form1->SpeedButton28,CubeArray[x][4][3]);
    FuncCIB(Form1->SpeedButton29,CubeArray[x][4][4]);
    FuncCIB(Form1->SpeedButton30,CubeArray[x][4][5]);
    FuncCIB(Form1->SpeedButton31,CubeArray[x][4][6]);
    FuncCIB(Form1->SpeedButton32,CubeArray[x][4][7]);

    FuncCIB(Form1->SpeedButton33,CubeArray[x][3][0]);
    FuncCIB(Form1->SpeedButton34,CubeArray[x][3][1]);
    FuncCIB(Form1->SpeedButton35,CubeArray[x][3][2]);
    FuncCIB(Form1->SpeedButton36,CubeArray[x][3][3]);
    FuncCIB(Form1->SpeedButton37,CubeArray[x][3][4]);
    FuncCIB(Form1->SpeedButton38,CubeArray[x][3][5]);
    FuncCIB(Form1->SpeedButton39,CubeArray[x][3][6]);
    FuncCIB(Form1->SpeedButton40,CubeArray[x][3][7]);

    FuncCIB(Form1->SpeedButton41,CubeArray[x][2][0]);
    FuncCIB(Form1->SpeedButton42,CubeArray[x][2][1]);
    FuncCIB(Form1->SpeedButton43,CubeArray[x][2][2]);
    FuncCIB(Form1->SpeedButton44,CubeArray[x][2][3]);
    FuncCIB(Form1->SpeedButton45,CubeArray[x][2][4]);
    FuncCIB(Form1->SpeedButton46,CubeArray[x][2][5]);
    FuncCIB(Form1->SpeedButton47,CubeArray[x][2][6]);
    FuncCIB(Form1->SpeedButton48,CubeArray[x][2][7]);

    FuncCIB(Form1->SpeedButton49,CubeArray[x][1][0]);
    FuncCIB(Form1->SpeedButton50,CubeArray[x][1][1]);
    FuncCIB(Form1->SpeedButton51,CubeArray[x][1][2]);
    FuncCIB(Form1->SpeedButton52,CubeArray[x][1][3]);
    FuncCIB(Form1->SpeedButton53,CubeArray[x][1][4]);
    FuncCIB(Form1->SpeedButton54,CubeArray[x][1][5]);
    FuncCIB(Form1->SpeedButton55,CubeArray[x][1][6]);
    FuncCIB(Form1->SpeedButton56,CubeArray[x][1][7]);

    FuncCIB(Form1->SpeedButton57,CubeArray[x][0][0]);
    FuncCIB(Form1->SpeedButton58,CubeArray[x][0][1]);
    FuncCIB(Form1->SpeedButton59,CubeArray[x][0][2]);
    FuncCIB(Form1->SpeedButton60,CubeArray[x][0][3]);
    FuncCIB(Form1->SpeedButton61,CubeArray[x][0][4]);
    FuncCIB(Form1->SpeedButton62,CubeArray[x][0][5]);
    FuncCIB(Form1->SpeedButton63,CubeArray[x][0][6]);
    FuncCIB(Form1->SpeedButton64,CubeArray[x][0][7]);
  }
  if(Layer>=17 && Layer<=24)
  {
    char y=FuncWhatNumberLayer();
    FuncCIB(Form1->SpeedButton1,CubeArray[7][y][7]);
    FuncCIB(Form1->SpeedButton2,CubeArray[6][y][7]);
    FuncCIB(Form1->SpeedButton3,CubeArray[5][y][7]);
    FuncCIB(Form1->SpeedButton4,CubeArray[4][y][7]);
    FuncCIB(Form1->SpeedButton5,CubeArray[3][y][7]);
    FuncCIB(Form1->SpeedButton6,CubeArray[2][y][7]);
    FuncCIB(Form1->SpeedButton7,CubeArray[1][y][7]);
    FuncCIB(Form1->SpeedButton8,CubeArray[0][y][7]);

    FuncCIB(Form1->SpeedButton9,CubeArray[7][y][6]);
    FuncCIB(Form1->SpeedButton10,CubeArray[6][y][6]);
    FuncCIB(Form1->SpeedButton11,CubeArray[5][y][6]);
    FuncCIB(Form1->SpeedButton12,CubeArray[4][y][6]);
    FuncCIB(Form1->SpeedButton13,CubeArray[3][y][6]);
    FuncCIB(Form1->SpeedButton14,CubeArray[2][y][6]);
    FuncCIB(Form1->SpeedButton15,CubeArray[1][y][6]);
    FuncCIB(Form1->SpeedButton16,CubeArray[0][y][6]);

    FuncCIB(Form1->SpeedButton17,CubeArray[7][y][5]);
    FuncCIB(Form1->SpeedButton18,CubeArray[6][y][5]);
    FuncCIB(Form1->SpeedButton19,CubeArray[5][y][5]);
    FuncCIB(Form1->SpeedButton20,CubeArray[4][y][5]);
    FuncCIB(Form1->SpeedButton21,CubeArray[3][y][5]);
    FuncCIB(Form1->SpeedButton22,CubeArray[2][y][5]);
    FuncCIB(Form1->SpeedButton23,CubeArray[1][y][5]);
    FuncCIB(Form1->SpeedButton24,CubeArray[0][y][5]);

    FuncCIB(Form1->SpeedButton25,CubeArray[7][y][4]);
    FuncCIB(Form1->SpeedButton26,CubeArray[6][y][4]);
    FuncCIB(Form1->SpeedButton27,CubeArray[5][y][4]);
    FuncCIB(Form1->SpeedButton28,CubeArray[4][y][4]);
    FuncCIB(Form1->SpeedButton29,CubeArray[3][y][4]);
    FuncCIB(Form1->SpeedButton30,CubeArray[2][y][4]);
    FuncCIB(Form1->SpeedButton31,CubeArray[1][y][4]);
    FuncCIB(Form1->SpeedButton32,CubeArray[0][y][4]);

    FuncCIB(Form1->SpeedButton33,CubeArray[7][y][3]);
    FuncCIB(Form1->SpeedButton34,CubeArray[6][y][3]);
    FuncCIB(Form1->SpeedButton35,CubeArray[5][y][3]);
    FuncCIB(Form1->SpeedButton36,CubeArray[4][y][3]);
    FuncCIB(Form1->SpeedButton37,CubeArray[3][y][3]);
    FuncCIB(Form1->SpeedButton38,CubeArray[2][y][3]);
    FuncCIB(Form1->SpeedButton39,CubeArray[1][y][3]);
    FuncCIB(Form1->SpeedButton40,CubeArray[0][y][3]);

    FuncCIB(Form1->SpeedButton41,CubeArray[7][y][2]);
    FuncCIB(Form1->SpeedButton42,CubeArray[6][y][2]);
    FuncCIB(Form1->SpeedButton43,CubeArray[5][y][2]);
    FuncCIB(Form1->SpeedButton44,CubeArray[4][y][2]);
    FuncCIB(Form1->SpeedButton45,CubeArray[3][y][2]);
    FuncCIB(Form1->SpeedButton46,CubeArray[2][y][2]);
    FuncCIB(Form1->SpeedButton47,CubeArray[1][y][2]);
    FuncCIB(Form1->SpeedButton48,CubeArray[0][y][2]);

    FuncCIB(Form1->SpeedButton49,CubeArray[7][y][1]);
    FuncCIB(Form1->SpeedButton50,CubeArray[6][y][1]);
    FuncCIB(Form1->SpeedButton51,CubeArray[5][y][1]);
    FuncCIB(Form1->SpeedButton52,CubeArray[4][y][1]);
    FuncCIB(Form1->SpeedButton53,CubeArray[3][y][1]);
    FuncCIB(Form1->SpeedButton54,CubeArray[2][y][1]);
    FuncCIB(Form1->SpeedButton55,CubeArray[1][y][1]);
    FuncCIB(Form1->SpeedButton56,CubeArray[0][y][1]);

    FuncCIB(Form1->SpeedButton57,CubeArray[7][y][0]);
    FuncCIB(Form1->SpeedButton58,CubeArray[6][y][0]);
    FuncCIB(Form1->SpeedButton59,CubeArray[5][y][0]);
    FuncCIB(Form1->SpeedButton60,CubeArray[4][y][0]);
    FuncCIB(Form1->SpeedButton61,CubeArray[3][y][0]);
    FuncCIB(Form1->SpeedButton62,CubeArray[2][y][0]);
    FuncCIB(Form1->SpeedButton63,CubeArray[1][y][0]);
    FuncCIB(Form1->SpeedButton64,CubeArray[0][y][0]);
  }
FuncOpenGL();
}





//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
if(CubeNumber==0)
{
  Button2->Enabled=false;
  Button69->Enabled=false;
}

// for OpenGL
   hDC = GetDC(Form1->Panel1->Handle);

   int PixelFormat;
   PIXELFORMATDESCRIPTOR pfd =
   {sizeof(PIXELFORMATDESCRIPTOR), 1,
      PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
      PFD_TYPE_RGBA, 24, 0,0,0,0,0,0, 0,0, 0,0,0,0,0, 32, 0,
      0, PFD_MAIN_PLANE, 0, 0,0,};
   PixelFormat = ChoosePixelFormat (hDC, &pfd);
   if (SetPixelFormat (hDC, PixelFormat, &pfd) == FALSE)
      Application->Terminate ();

   hGLRC = wglCreateContext(hDC);
   if(hGLRC == NULL) Application->Terminate ();
   if(wglMakeCurrent(hDC, hGLRC) == false) Application->Terminate ();

   glEnable (GL_DEPTH_TEST);

   glViewport (0, 0, Form1->Panel1->Width, Form1->Panel1->Height);

   glShadeModel (GL_SMOOTH);
   glClearColor (0.0, 0.0, 0.0, 0.0);

   glMatrixMode (GL_PROJECTION);
   glLoadIdentity ();
   gluPerspective (90, GLdouble(Form1->Panel1->Width/Form1->Panel1->Height), 1.0, 100.0);

   glMatrixMode (GL_MODELVIEW);
   glLoadIdentity ();
   gluLookAt (0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);
   // for OpenGL

}


//---------------------------------------------------------------------------

void __fastcall TForm1::Open1Click(TObject *Sender)
{
OpenDialog1->Execute();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Save1Click(TObject *Sender)
{
FuncCubeArrayFile();
FILE *file;
char *fname="001.bin";
file = fopen(fname,"w");
fwrite(CubeArrayFile,sizeof(CubeArrayFile),1,file);
//fwrite(CubeArrayFile,strlen(CubeArrayFile),1,file);
fclose(file);
//SaveDialog1->Execute()



}
//---------------------------------------------------------------------------


void __fastcall TForm1::About1Click(TObject *Sender)
{
Form3->Show();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
Layer=1;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=false;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton2Click(TObject *Sender)
{
Layer=2;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton3Click(TObject *Sender)
{
Layer=3;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton4Click(TObject *Sender)
{
Layer=4;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton5Click(TObject *Sender)
{
Layer=5;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton6Click(TObject *Sender)
{
Layer=6;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton7Click(TObject *Sender)
{
Layer=7;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton8Click(TObject *Sender)
{
Layer=8;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton9Click(TObject *Sender)
{
Layer=9;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=false;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton10Click(TObject *Sender)
{
Layer=10;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton11Click(TObject *Sender)
{
Layer=11;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton12Click(TObject *Sender)
{
Layer=12;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton13Click(TObject *Sender)
{
Layer=13;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton14Click(TObject *Sender)
{
Layer=14;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton15Click(TObject *Sender)
{
Layer=15;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton16Click(TObject *Sender)
{
Layer=16;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton17Click(TObject *Sender)
{
Layer=17;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=false;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton18Click(TObject *Sender)
{
Layer=18;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton19Click(TObject *Sender)
{
Layer=19;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton20Click(TObject *Sender)
{
Layer=20;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton21Click(TObject *Sender)
{
Layer=21;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton22Click(TObject *Sender)
{
Layer=22;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton23Click(TObject *Sender)
{
Layer=23;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton24Click(TObject *Sender)
{
Layer=24;
FuncChangeImageArrow(Image2,Image3,Image4,Label1,Label2,Label3,Label6);
FuncDrow();
Form1->Button68->Enabled=true;
Form1->Button3->Enabled=false;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[7][7][n],SpeedButton1);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][7][0],SpeedButton1);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[7][n][7],SpeedButton1);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[6][7][n],SpeedButton2);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][7][1],SpeedButton2);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[6][n][7],SpeedButton2);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[5][7][n],SpeedButton3);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][7][2],SpeedButton3);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[5][n][7],SpeedButton3);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[4][7][n],SpeedButton4);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][7][3],SpeedButton4);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[4][n][7],SpeedButton4);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton5Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[3][7][n],SpeedButton5);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][7][4],SpeedButton5);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[3][n][7],SpeedButton5);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[2][7][n],SpeedButton6);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][7][5],SpeedButton6);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[2][n][7],SpeedButton6);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton7Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[1][7][n],SpeedButton7);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][7][6],SpeedButton7);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[1][n][7],SpeedButton7);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton8Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[0][7][n],SpeedButton8);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][7][7],SpeedButton8);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[0][n][7],SpeedButton8);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton9Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[7][6][n],SpeedButton9);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][6][0],SpeedButton9);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[7][n][6],SpeedButton9);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton10Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[6][6][n],SpeedButton10);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][6][1],SpeedButton10);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[6][n][6],SpeedButton10);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton11Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[5][6][n],SpeedButton11);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][6][2],SpeedButton11);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[5][n][6],SpeedButton11);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton12Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[4][6][n],SpeedButton12);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][6][3],SpeedButton12);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[4][n][6],SpeedButton12);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton13Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[3][6][n],SpeedButton13);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][6][4],SpeedButton13);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[3][n][6],SpeedButton13);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton14Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[2][6][n],SpeedButton14);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][6][5],SpeedButton14);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[2][n][6],SpeedButton14);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton15Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[1][6][n],SpeedButton15);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][6][6],SpeedButton15);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[1][n][6],SpeedButton15);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton16Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[0][6][n],SpeedButton16);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][6][7],SpeedButton16);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[0][n][6],SpeedButton16);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton17Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[7][5][n],SpeedButton17);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][5][0],SpeedButton17);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[7][n][5],SpeedButton17);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton18Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[6][5][n],SpeedButton18);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][5][1],SpeedButton18);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[6][n][5],SpeedButton18);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton19Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[5][5][n],SpeedButton19);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][5][2],SpeedButton19);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[5][n][5],SpeedButton19);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton20Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[4][5][n],SpeedButton20);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][5][3],SpeedButton20);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[4][n][5],SpeedButton20);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton21Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[3][5][n],SpeedButton21);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][5][4],SpeedButton21);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[3][n][5],SpeedButton21);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton22Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[2][5][n],SpeedButton22);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][5][5],SpeedButton22);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[2][n][5],SpeedButton22);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton23Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[1][5][n],SpeedButton23);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][5][6],SpeedButton23);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[1][n][5],SpeedButton23);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton24Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[0][5][n],SpeedButton24);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][5][7],SpeedButton24);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[0][n][5],SpeedButton24);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton25Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[7][4][n],SpeedButton25);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][4][0],SpeedButton25);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[7][n][4],SpeedButton25);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton26Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[6][4][n],SpeedButton26);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][4][1],SpeedButton26);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[6][n][4],SpeedButton26);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton27Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[5][4][n],SpeedButton27);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][4][2],SpeedButton27);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[5][n][4],SpeedButton27);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton28Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[4][4][n],SpeedButton28);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][4][3],SpeedButton28);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[4][n][4],SpeedButton28);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton29Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[3][4][n],SpeedButton29);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][4][4],SpeedButton29);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[3][n][4],SpeedButton29);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton30Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[2][4][n],SpeedButton30);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][4][5],SpeedButton30);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[2][n][4],SpeedButton30);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton31Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[1][4][n],SpeedButton31);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][4][6],SpeedButton31);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[1][n][4],SpeedButton31);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton32Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[0][4][n],SpeedButton32);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][4][7],SpeedButton32);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[0][n][4],SpeedButton32);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton33Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[7][3][n],SpeedButton33);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][3][0],SpeedButton33);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[7][n][3],SpeedButton33);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton34Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[6][3][n],SpeedButton34);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][3][1],SpeedButton34);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[6][n][3],SpeedButton34);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton35Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[5][3][n],SpeedButton35);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][3][2],SpeedButton35);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[5][n][3],SpeedButton35);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton36Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[4][3][n],SpeedButton36);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][3][3],SpeedButton36);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[4][n][3],SpeedButton36);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton37Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[3][3][n],SpeedButton37);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][3][4],SpeedButton37);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[3][n][3],SpeedButton37);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton38Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[2][3][n],SpeedButton38);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][3][5],SpeedButton38);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[2][n][3],SpeedButton38);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton39Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[1][3][n],SpeedButton39);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][3][6],SpeedButton39);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[1][n][3],SpeedButton39);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton40Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[0][3][n],SpeedButton40);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][3][7],SpeedButton40);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[0][n][3],SpeedButton40);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton41Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[7][2][n],SpeedButton41);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][2][0],SpeedButton41);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[7][n][2],SpeedButton41);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton42Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[6][2][n],SpeedButton42);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][2][1],SpeedButton42);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[6][n][2],SpeedButton42);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton43Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[5][2][n],SpeedButton43);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][2][2],SpeedButton43);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[5][n][2],SpeedButton43);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton44Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[4][2][n],SpeedButton44);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][2][3],SpeedButton44);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[4][n][2],SpeedButton44);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton45Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[3][2][n],SpeedButton45);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][2][4],SpeedButton45);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[3][n][2],SpeedButton45);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton46Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[2][2][n],SpeedButton46);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][2][5],SpeedButton46);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[2][n][2],SpeedButton46);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton47Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[1][2][n],SpeedButton47);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][2][6],SpeedButton47);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[1][n][2],SpeedButton47);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton48Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[0][2][n],SpeedButton48);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][2][7],SpeedButton48);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[0][n][2],SpeedButton48);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton49Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[7][1][n],SpeedButton49);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][1][0],SpeedButton49);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[7][n][1],SpeedButton49);} // Y
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton50Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[6][1][n],SpeedButton50);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][1][1],SpeedButton50);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[6][n][1],SpeedButton50);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton51Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[5][1][n],SpeedButton51);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][1][2],SpeedButton51);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[5][n][1],SpeedButton51);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton52Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[4][1][n],SpeedButton52);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][1][3],SpeedButton52);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[4][n][1],SpeedButton52);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton53Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[3][1][n],SpeedButton53);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][1][4],SpeedButton53);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[3][n][1],SpeedButton53);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton54Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[2][1][n],SpeedButton54);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][1][5],SpeedButton54);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[2][n][1],SpeedButton54);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton55Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[1][1][n],SpeedButton55);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][1][6],SpeedButton55);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[1][n][1],SpeedButton55);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton56Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[0][1][n],SpeedButton56);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][1][7],SpeedButton56);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[0][n][1],SpeedButton56);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton57Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[7][0][n],SpeedButton57);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][0][0],SpeedButton57);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[7][n][0],SpeedButton57);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton58Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[6][0][n],SpeedButton58);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][0][1],SpeedButton58);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[6][n][0],SpeedButton58);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton59Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[5][0][n],SpeedButton59);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][0][2],SpeedButton59);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[5][n][0],SpeedButton59);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton60Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[4][0][n],SpeedButton60);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][0][3],SpeedButton60);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[4][n][0],SpeedButton60);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton61Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[3][0][n],SpeedButton61);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][0][4],SpeedButton61);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[3][n][0],SpeedButton61);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton62Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[2][0][n],SpeedButton62);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][0][5],SpeedButton62);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[2][n][0],SpeedButton62);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton63Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[1][0][n],SpeedButton63);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][0][6],SpeedButton63);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[1][n][0],SpeedButton63);} // Y
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton64Click(TObject *Sender)
{
  char n=FuncWhatNumberLayer();
  if(Layer>=1 && Layer<=8){FuncChangeStates(CubeArray[0][0][n],SpeedButton64);}   // Z
  if(Layer>=9 && Layer<=16){FuncChangeStates(CubeArray[n][0][7],SpeedButton64);}  // X
  if(Layer>=17 && Layer<=24){FuncChangeStates(CubeArray[0][n][0],SpeedButton64);} // Y
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button65Click(TObject *Sender)
{
FuncButtonLayer(1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button66Click(TObject *Sender)
{
FuncButtonLayer(-1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button67Click(TObject *Sender)
{
FuncClearLayer();
FuncDrow();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button68Click(TObject *Sender)
{
FuncDuplicateLayerPrev();
FuncDrow();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button70Click(TObject *Sender)
{
FuncChangeCube(1);
FuncDrow();
Form1->Label7->Caption=CubeNumber;
Button2->Enabled=true;
if(CubeNumber==507)Button1->Enabled=false;
Form1->ScrollBar1->Position=CubeNumber;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button69Click(TObject *Sender)
{
FuncChangeCube(-1);
FuncDrow();
Form1->Label7->Caption=CubeNumber;
if(CubeNumber==0)Button2->Enabled=false;
Button1->Enabled=true;
Form1->ScrollBar1->Position=CubeNumber;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button3Click(TObject *Sender)
{
FuncDuplicateLayerNext();
FuncDrow();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
FuncChangeCubeNum(Form1->ScrollBar1->Position);
Form1->Label7->Caption=CubeNumber;
if(CubeNumber==507)
 {
  Form1->Button1->Enabled=false;
  Form1->Button70->Enabled=false;
 }
else
 {
  Form1->Button1->Enabled=true;
  Form1->Button70->Enabled=true;
 }
if(CubeNumber==0)
 {
  Form1->Button2->Enabled=false;
  Form1->Button69->Enabled=false;
 }
else
 {
  Form1->Button2->Enabled=true;
  Form1->Button69->Enabled=true;
 }
FuncDrow();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button1Click(TObject *Sender)
{
Form1->Label8->Caption=" ";
int Quantity=StrToInt(Form1->Edit1->Text);
FuncDuplicateCube(1,Quantity);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button2Click(TObject *Sender)
{
Form1->Label8->Caption=" ";
int Quantity=StrToInt(Form1->Edit1->Text);
FuncDuplicateCube(-1,Quantity);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button4Click(TObject *Sender)
{
FuncInsertCube();
FuncClearCube();
FuncDrow();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   if (hGLRC)
   {
      wglMakeCurrent(NULL, NULL);
      wglDeleteContext(hGLRC);
      hGLRC = NULL;
   }
   if (hDC)
   {
      ReleaseDC(Handle, hDC);
      hDC = NULL;
   }        
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button6Click(TObject *Sender)
{
RotX=RotX+10;
if(RotX>359)
 {
 RotX=0;
 }
Form1->Label12->Caption=RotX;
FuncOpenGL();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
RotX=RotX-10;
if(RotX<0)
 {
 RotX=350;
 }
Form1->Label12->Caption=RotX;
FuncOpenGL();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
RotY=RotY+10;
if(RotY>359)
 {
 RotY=0;
 }
Form1->Label13->Caption=RotY;
FuncOpenGL();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
RotY=RotY-10;
if(RotY<0)
 {
 RotY=350;
 }
Form1->Label13->Caption=RotY;
FuncOpenGL();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)
{
RotZ=RotZ-10;
if(RotZ<0)
 {
 RotZ=350;
 }
Form1->Label14->Caption=RotZ;
FuncOpenGL();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{
RotZ=RotZ+10;
if(RotZ>359)
 {
 RotZ=0;
 }
Form1->Label14->Caption=RotZ;
FuncOpenGL();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
if(gl_lines==true)gl_lines=false;
else gl_lines=true;
FuncOpenGL();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
if(var_timer==true)
 {
  FuncChangeCube(1);
  FuncDrow();
  Form1->Label7->Caption=CubeNumber;
  Button2->Enabled=true;
  if(CubeNumber==507)
   {
    Button1->Enabled=false;
    var_timer=false;
   }
  Form1->ScrollBar1->Position=CubeNumber;
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button13Click(TObject *Sender)
{
int Quantity=StrToInt(Form1->Edit2->Text);
Form1->Timer1->Interval=Quantity;
var_timer=true;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button12Click(TObject *Sender)
{
var_timer=false;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button14Click(TObject *Sender)
{
fa=fa-0.1;
FuncOpenGL();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button15Click(TObject *Sender)
{
fa=fa+0.1;
FuncOpenGL();
}
//---------------------------------------------------------------------------



